/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.dokumente;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.dokumente.boundary.AbstractDokumentVorlageSearchParameters;
import de.ivu.elect.business.dokumente.boundary.DokumentVorlageChangeEvent;
import de.ivu.elect.business.dokumente.boundary.DokumentVorlageConversationStore;
import de.ivu.elect.business.dokumente.boundary.DokumentVorlageExtendedDAO;
import de.ivu.elect.business.dokumente.boundary.DokumentVorlageSearch;
import de.ivu.elect.business.dokumente.boundary.DokumentVorlageSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.dokumente.entity.DokumentVorlage;
import de.ivu.elect.business.dokumente.entity.DokumentVorlageMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractDokumentVorlageSearchView.COMPONENT_NAME)
@View(viewId = AbstractDokumentVorlageSearchView.VIEW_ID, useCase = UseCasePermission.DOKUMENT_VORLAGE_SEARCH)
public abstract class AbstractDokumentVorlageSearchView extends AbstractElectSearchView<DokumentVorlage> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "dokumentVorlageSearchView";
  
  public static final String VIEW_ID = "/dokumente/dokument-vorlage-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractDokumentVorlageSearchView requestHandler;

  @Inject
  private transient DokumentVorlageExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(DokumentVorlageConversationStore.class)
  protected transient DokumentVorlageConversationStore conversationStore;

  @Inject
  protected transient DokumentVorlageSearch search;

  @Inject
  @ConversationGroup(AbstractDokumentVorlageSearchParameters.class)
  protected transient DokumentVorlageSearchParameters searchParameters;

  @Inject
  protected transient DokumentVorlageMeta entityMeta;

  public AbstractDokumentVorlageSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public DokumentVorlage getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(DokumentVorlage entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public DokumentVorlageSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<DokumentVorlage> getEagerLoadingCollector() {
    return EagerLoadingCollector.<DokumentVorlage> create();
  }

  @Override
  public List<DokumentVorlage> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<DokumentVorlage> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onDokumentVorlageChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) DokumentVorlageChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  // elect: Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractDokumentVorlageSearchView {

    @View
    @Inject
    private transient Instance<AbstractDokumentVorlageSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractDokumentVorlageSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
